commit:     9cdf46e78845fbeeef00ebabed3ed08c5d71b51e
Author:     Kyle Elbert <kcelbert <AT> gmail <DOT> com>
AuthorDate: Sun Mar 31 02:05:08 2019 +0000
Commit:     Alice Ferrazzi <alicef <AT> gentoo <DOT> org>
CommitDate: Tue Apr  9 02:41:56 2019 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=9cdf46e7

dev-util/idea-community: bump to 2019.1 and Split custom-jdk useflag

Upstream now offers a Java 11 based Jetbrains Runtime,
while continuing to offer their Java 8 based runtime as the default download

Closes: https://bugs.gentoo.org/653144
Closes: https://bugs.gentoo.org/676370
Closes: https://bugs.gentoo.org/676900
Closes: https://bugs.gentoo.org/640688
Package-Manager: Portage-2.3.62, Repoman-2.3.12
Signed-off-by: Kyle Elbert <kcelbert <AT> gmail.com>
Signed-off-by: Alice Ferrazzi <alicef <AT> gentoo.org>

 dev-util/idea-community/Manifest                   |   4 +
 .../idea-community-2019.1.191.6183.87.ebuild       | 112 +++++++++++++++++++++
 dev-util/idea-community/metadata.xml               |   2 +
 3 files changed, 118 insertions(+)

diff --git a/dev-util/idea-community/Manifest b/dev-util/idea-community/Manifest
index 286ba55f3d2..775978eb84c 100644
--- a/dev-util/idea-community/Manifest
+++ b/dev-util/idea-community/Manifest
@@ -2,5 +2,9 @@ DIST ideaIC-172.3757.52.tar.gz 442963100 BLAKE2B 
e44f924e279a5b8f2bddbe65cffa243
 DIST ideaIC-183.4588.61.tar.gz 541751086 BLAKE2B 
51a5a4dae10d8fd00a0c239f87af3d53b86ffa50f7f9c4f1554265b349d866d60a8994a96f184cc9993fafe12de3dbfa77e3931626436a5f3d3854710b52fb9e
 SHA512 
3e5956353fc0fabbe91b3a946e83b0b3229766a366fdf782c4c017acd7de5a86b3e0cc870a17abe2bdb8b090cb5c58b6c170555f60ba5e6a9a8198073545be87
 DIST ideaIC-183.5153.38.tar.gz 541754349 BLAKE2B 
541054736db09c8f0106d5588b224d3033ec21a1e2b566fbc95300fafd39acae5c7f6755082bdb189c5619ed5375ea9fc3e777440d30523a84f864be29e5ad85
 SHA512 
0bb213da8bffda7d63fa29905d01ee36c3839249dd6e2a58b3941e4317a01bd9315e8bf639f088657938c8197eb2f05fc34fb3e0c49f8c243043cb03f8443f0f
 DIST ideaIC-183.5429.30.tar.gz 460232784 BLAKE2B 
53cd69f5e8927b31a34b23f9e86e0974152cd6282eb4597aa173c06895e1b431360b18c76442094fb9f544bc29f925397242d42943b51840156f8b332e0d5357
 SHA512 
36c5151410c15e4530af1da5ccfb981ca4fba00577b26fb76fd3470bc3818f2b08b4545ca7ab2979dc87f144712f864811cf73336cf5ff98cb5f63c0e61e1a9c
+DIST ideaIC-191.6183.87.tar.gz 496360045 BLAKE2B 
12164308d161c9ac5249baa0e2ec6ec88b96e9e37e25fa1befa5660142a530b40c5fa7bbbac6a6fbea0297de7ba6bcb557b139ea213f5fd75342ec0e12956ee9
 SHA512 
3c56a265f74c80e15b88a6121d1c462b6a3e394893c0ab522b2935af29e5c830245d9038208bc5358285714969ffd192e1e8c52bd5ac8e5b0425b8a5a1224c7b
+DIST jbr-11_0_2-linux-x64-b164.tar.gz 131483925 BLAKE2B 
fb9c55094aeb4a9e6b89ef41699252355895fa4bf55eaa0d3c0a637b6485b5a91a0445b5f4af1872b62cd67b639f7354e05770970d41dcfa58ffeda7ae43c5b6
 SHA512 
4f32940166cc8ad5a138866e18d4cbfcd07f4326a85c051b7a622c9dcb8ee4b6d493331ef24d0c01999134fa2a9bad901f026982c16780fdc5e6b9308821db34
 DIST jbrx-8u202-linux-i586-b1483.24.tar.gz 80740809 BLAKE2B 
cc420ac646120c7060a3a7697e2a0f1d8a6f9702b1c2d2730f339e7aed405ccf4bb31d4be389686f57066f6add5e8279912e54fd341873ad2c2d1f5292b4d14f
 SHA512 
90280f8a36fa8f20448c27d344de85ae06412f0b1fc717b77b5fbdcc0a3486e0def510e4ef0aedc1eb210b1e3541b0e37f805821731a285c6e78eb87ad083f2d
+DIST jbrx-8u202-linux-i586-b1483.37.tar.gz 80726147 BLAKE2B 
e4e5a076a541fd7153e861193ff4247c02ecbc144396ed28737afa7440f7771569b8d968b7c67b3dac333a89ff0b54cc9e5e76d1651b174cc7c0c21b1deb033c
 SHA512 
53693f2ce994f4891807873ae3fe46ce60bee000b78be03c5d3df06b436328abe5b5d7e75d43e57f35f24187f49915187d034b39589e29806f55deeb14a029f2
 DIST jbrx-8u202-linux-x64-b1483.24.tar.gz 81829687 BLAKE2B 
b716ca394a1315d8d6c6ebd57fd35cc37db6429380681c6d5e7d05b4a00036c1aca46820b0a17b824c8742e7ba924b4342eedf08999370c7a9fd2675f99d45a3
 SHA512 
08db0eb7fc2b5ae734120f276f96f21fe9e6c2bcb84a833fe5a1a8bb3b9b1205c3de06e1c1ad94e220c26f092061d5ec99470619240630f7722d1d64d21ace97
+DIST jbrx-8u202-linux-x64-b1483.37.tar.gz 81812743 BLAKE2B 
86ddf0c8dc992a27e680caa821f54fa4d647a8bff78b9fdbef82996bfbba828a2f68f1a00ed64bd92ce24a62bfc6c0240837c396644c6e91244cb0d980b6c704
 SHA512 
cd31a3c4da7b8c65e9ae89326c2c8b260b51890258d30f64b1e8a7c6c1442bb2cb68ea2aa80387ce0c1a8f50e3533e8231f72c5935b639e3cf82bc1ffedee8e9

diff --git a/dev-util/idea-community/idea-community-2019.1.191.6183.87.ebuild 
b/dev-util/idea-community/idea-community-2019.1.191.6183.87.ebuild
new file mode 100644
index 00000000000..5d9d1f8af94
--- /dev/null
+++ b/dev-util/idea-community/idea-community-2019.1.191.6183.87.ebuild
@@ -0,0 +1,112 @@
+# Copyright 1999-2019 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+inherit eutils desktop
+
+SLOT="0"
+PV_STRING="$(ver_cut 3-6)"
+MY_PV="$(ver_cut 1-2)"
+MY_PN="idea"
+#Using the most recent Jetbrains Runtime binaries available at the time of 
writing
+#As the exact bundled versions ( jre 11 build 159.30 and jre 8 build 1483.39 ) 
arn't
+#Available seperately
+JRE11_BASE="11_0_2"
+JRE11_VER="164"
+JRE_BASE="8u202"
+JRE_VER="1483.37"
+
+# distinguish settings for official stable releases and EAP-version releases
+if [[ "$(ver_cut 7)"x = "prex" ]]
+then
+       # upstream EAP
+       KEYWORDS=""
+       
SRC_URI="https://download.jetbrains.com/idea/${MY_PN}IC-${PV_STRING}.tar.gz";
+else
+       # upstream stable
+       KEYWORDS="~amd64 ~x86"
+       
SRC_URI="https://download.jetbrains.com/idea/${MY_PN}IC-${MY_PV}-no-jbr.tar.gz 
-> ${MY_PN}IC-${PV_STRING}.tar.gz
+          jbr8? ( x86? ( 
https://bintray.com/jetbrains/intellij-jdk/download_file?file_path=jbrx-${JRE_BASE}-linux-i586-b${JRE_VER}.tar.gz
 -> jbrx-${JRE_BASE}-linux-i586-b${JRE_VER}.tar.gz )
+               amd64? ( 
https://bintray.com/jetbrains/intellij-jdk/download_file?file_path=jbrx-${JRE_BASE}-linux-x64-b${JRE_VER}.tar.gz
 -> jbrx-${JRE_BASE}-linux-x64-b${JRE_VER}.tar.gz ) )
+        jbr11? ( amd64? ( 
https://bintray.com/jetbrains/intellij-jdk/download_file?file_path=jbr-${JRE11_BASE}-linux-x64-b${JRE11_VER}.tar.gz
 -> jbr-${JRE11_BASE}-linux-x64-b${JRE11_VER}.tar.gz ) )"
+fi
+
+DESCRIPTION="A complete toolset for web, mobile and enterprise development"
+HOMEPAGE="https://www.jetbrains.com/idea";
+
+LICENSE="Apache-2.0
+       jbr8? ( GPL-2 )
+       jbr11? ( GPL-2 )
+       "
+#Splitting custom-jdk into jbr8 and jbr11 as upstream now offers downloads with
+#either (or neither) bundled
+#Defaulting to jbr8 to match upstream
+IUSE="+jbr8 -jbr11"
+REQUIRED_USE="jbr8? ( !jbr11 )"
+
+DEPEND="!dev-util/${PN}:14
+       !dev-util/${PN}:15"
+RDEPEND="${DEPEND}
+       >=virtual/jdk-1.7:*"
+S="${WORKDIR}/${MY_PN}-IC-${PV_STRING}"
+
+QA_PREBUILT="opt/${PN}-${MY_PV}/*"
+
+# jbr11 binary doesn't unpack nicely into a single folder
+src_unpack() {
+if use !jbr11 ; then
+default_src_unpack
+else
+cd "${WORKDIR}"
+unpack ${MY_PN}IC-${PV_STRING}.tar.gz
+cd "${S}"
+mkdir jre64 && cd jre64 && unpack 
jbr-${JRE11_BASE}-linux-x64-b${JRE11_VER}.tar.gz
+fi
+}
+src_prepare() {
+       if use amd64; then
+               JRE_DIR=jre64
+       else
+               JRE_DIR=jre
+       fi
+       if use jbr8; then
+                       mv "${WORKDIR}/jre" ./"${JRE_DIR}"
+       fi
+       if ! use arm; then
+               rm bin/fsnotifier-arm || die
+       fi
+       eapply_user
+}
+
+src_install() {
+       local dir="/opt/${PN}-${MY_PV}"
+
+       insinto "${dir}"
+       doins -r *
+       fperms 755 
"${dir}"/bin/{format.sh,idea.sh,inspect.sh,printenv.py,restart.py,fsnotifier{,64}}
+       if use amd64; then
+               JRE_DIR=jre64
+       else
+               JRE_DIR=jre
+       fi
+       if use jbr8 || use jbr11 ; then
+       if use jbr8; then
+               JRE_BINARIES="java jjs keytool orbd pack200 policytool rmid 
rmiregistry servertool tnameserv unpack200"
+       else
+               JRE_BINARIES="jaotc java javapackager jjs jrunscript keytool 
pack200 rmid rmiregistry unpack200"
+       fi
+               if [[ -d ${JRE_DIR} ]]; then
+                       for jrebin in $JRE_BINARIES; do
+                               fperms 755 "${dir}"/"${JRE_DIR}"/bin/"${jrebin}"
+                       done
+               fi
+       fi
+
+       make_wrapper "${PN}" "${dir}/bin/${MY_PN}.sh"
+       newicon "bin/${MY_PN}.png" "${PN}.png"
+       make_desktop_entry "${PN}" "IntelliJ Idea Community" "${PN}" 
"Development;IDE;"
+
+       # recommended by: 
https://confluence.jetbrains.com/display/IDEADEV/Inotify+Watches+Limit
+       mkdir -p "${D}/etc/sysctl.d/" || die
+       echo "fs.inotify.max_user_watches = 524288" > 
"${D}/etc/sysctl.d/30-idea-inotify-watches.conf" || die
+}

diff --git a/dev-util/idea-community/metadata.xml 
b/dev-util/idea-community/metadata.xml
index 695fd92bb18..5ca8720092a 100644
--- a/dev-util/idea-community/metadata.xml
+++ b/dev-util/idea-community/metadata.xml
@@ -10,5 +10,7 @@
 </longdescription>
 <use>
        <flag name="custom-jdk">Install and use IntelliJ's custom JRE.</flag>
+       <flag name="jbr8">Install and use the Java 8 based version of JetBrains 
Runtime.</flag>
+       <flag name="jbr11">Install and use the Java 11 based version of 
JetBrains Runtime.</flag>
 </use>
 </pkgmetadata>

Reply via email to